package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowFloatingIPDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowFloatingIPDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowFloatingIPDetailsLogic {
	return &ShowFloatingIPDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowFloatingIPDetailsLogic) ShowFloatingIPDetails(req *types.ShowFloatingIPDetailsReq) (resp *types.ShowFloatingIPDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowFloatingIPDetailsReq := &openstack.ShowFloatingIPDetailsReq{}
	err = copier.CopyWithOption(ShowFloatingIPDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowFloatingIPDetailsResp, err := l.svcCtx.OpenstackRpc.ShowFloatingIPDetails(l.ctx, ShowFloatingIPDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowFloatingIPDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowFloatingIPDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
